Index: /extensions/SmartAlbums/admin.php
===================================================================
--- /extensions/SmartAlbums/admin.php	(revision 16103)
+++ /extensions/SmartAlbums/admin.php	(revision 16104)
@@ -4,22 +4,28 @@
 global $conf, $template, $page;
 
-load_language('plugin.lang', SMART_PATH);
-if (!is_array($conf['SmartAlbums'])) $conf['SmartAlbums'] = unserialize($conf['SmartAlbums']);
+$page['tab'] = (isset($_GET['tab'])) ? $_GET['tab'] : $page['tab'] = 'cat_list';
 
-include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
-$page['tab'] = (isset($_GET['tab'])) ? $_GET['tab'] : $page['tab'] = 'albums';
-  
-$tabsheet = new tabsheet();
-$tabsheet->add('albums', l10n('All SmartAlbums'), SMART_ADMIN.'-albums');
-$tabsheet->add('config', l10n('Configuration'),   SMART_ADMIN.'-config');
-$tabsheet->select($page['tab']);
-$tabsheet->assign();
+if ($page['tab'] == 'album')
+{
+  include(SMART_PATH . 'admin/album.php');
+}
+else
+{
+  include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
+  $tabsheet = new tabsheet();
+  $tabsheet->add('cat_list', l10n('All SmartAlbums'), SMART_ADMIN.'-cat_list');
+  $tabsheet->add('config', l10n('Configuration'), SMART_ADMIN.'-config');
+  $tabsheet->select($page['tab']);
+  $tabsheet->assign();
 
-$template->assign(array(
-  'SMART_PATH' => SMART_PATH,
-));
+  $template->assign(array(
+    'SMART_PATH' => SMART_PATH,
+  ));
 
-include(SMART_PATH.'admin/'.$page['tab'].'.inc.php');
-$template->set_filename('SmartAlbums_content', dirname(__FILE__).'/admin/template/'.$page['tab'].'.tpl');
+  include(SMART_PATH . 'admin/'.$page['tab'].'.php');
+}
+
+$template->assign('SMART_PATH', SMART_PATH);
+
 $template->assign_var_from_handle('ADMIN_CONTENT', 'SmartAlbums_content');
 
Index: /extensions/SmartAlbums/admin/album.php
===================================================================
--- /extensions/SmartAlbums/admin/album.php	(revision 16104)
+++ /extensions/SmartAlbums/admin/album.php	(revision 16104)
@@ -0,0 +1,252 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+if(!defined("PHPWG_ROOT_PATH")) die ("Hacking attempt!");
+
+// +-----------------------------------------------------------------------+
+// | Basic checks                                                          |
+// +-----------------------------------------------------------------------+
+
+check_status(ACCESS_ADMINISTRATOR);
+
+check_input_parameter('cat_id', $_GET, false, PATTERN_ID);
+
+$admin_album_base_url = get_root_url().'admin.php?page=album-'.$_GET['cat_id'];
+$self_url = SMART_ADMIN.'-album&amp;cat_id='.$_GET['cat_id'];
+
+$query = '
+SELECT *
+  FROM '.CATEGORIES_TABLE.'
+  WHERE id = '.$_GET['cat_id'].'
+;';
+$category = pwg_db_fetch_assoc(pwg_query($query));
+
+if (!isset($category['id']))
+{
+  die("unknown album");
+}
+
+// +-----------------------------------------------------------------------+
+// | Tabs                                                                  |
+// +-----------------------------------------------------------------------+
+
+include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
+$tabsheet = new tabsheet();
+$tabsheet->add('properties', l10n('Properties'), $admin_album_base_url.'-properties');
+$tabsheet->add('sort_order', l10n('Manage photo ranks'), $admin_album_base_url.'-sort_order');
+$tabsheet->add('permissions', l10n('Permissions'), $admin_album_base_url.'-permissions');
+$tabsheet->add('notification', l10n('Notification'), $admin_album_base_url.'-notification');
+$tabsheet->add('smartalbum', 'SmartAlbum', $self_url);
+$tabsheet->select('smartalbum');
+$tabsheet->assign();
+
+
+$cat_id = $_GET['cat_id'];
+
+// category must be virtual
+if ($category['dir'] != NULL)
+{
+  die("physical album");
+}
+
+// +-----------------------------------------------------------------------+
+// | Save Filters                                                          |
+// +-----------------------------------------------------------------------+
+
+if (isset($_POST['submitFilters']))
+{
+  // test if it was a Smart Album
+  $query = '
+SELECT DISTINCT category_id 
+  FROM '.CATEGORY_FILTERS_TABLE.' 
+  WHERE category_id = '.$cat_id.'
+;';
+  $was_smart = pwg_db_num_rows(pwg_query($query));
+  
+  /* this album is no longer a SmartAlbum */
+  if ( $was_smart AND !isset($_POST['is_smart']) )
+  {
+    pwg_query('DELETE FROM '.IMAGE_CATEGORY_TABLE.' WHERE category_id = '.$cat_id.' AND smart = true;');
+    pwg_query('DELETE FROM '.CATEGORY_FILTERS_TABLE.' WHERE category_id = '.$cat_id.';');
+    set_random_representant(array($cat_id));
+    invalidate_user_cache();
+  }
+  /* no filter selected */
+  else if ( isset($_POST['is_smart']) AND empty($_POST['filters']) )
+  {
+    array_push($page['errors'], l10n('No filter selected'));
+  }
+  /* everything is fine */
+  else if ( isset($_POST['is_smart']) )
+  {
+    pwg_query('DELETE FROM '.CATEGORY_FILTERS_TABLE.' WHERE category_id = '.$cat_id.';');
+    
+    foreach ($_POST['filters'] as $filter)
+    {
+      if (($filter = smart_check_filter($filter)) != false)
+      {
+        $query = '
+INSERT IGNORE INTO '.CATEGORY_FILTERS_TABLE.' 
+  VALUES(
+    '.$cat_id.', 
+    "'.$filter['type'].'", 
+    "'.$filter['cond'].'", 
+    "'.$filter['value'].'"
+  )
+;';
+      pwg_query($query);
+      }
+    }
+    
+    $associated_images = smart_make_associations($cat_id);
+    $template->assign('IMAGE_COUNT', l10n_dec('%d photo', '%d photos', count($associated_images)));
+    
+    array_push($page['infos'], sprintf('%d photos associated to the album %s', count($associated_images), ''));
+    
+    define('SMART_NOT_UPDATE', 1);
+    invalidate_user_cache();
+  }
+}
+
+// +-----------------------------------------------------------------------+
+// | Display page                                                          |
+// +-----------------------------------------------------------------------+
+
+/* select options, for html_options */
+$template->assign(
+  'options', 
+  array(
+    'tags' => array(
+      'all'   => l10n('All these tags'),
+      'one'   => l10n('One of these tags'),
+      'none'  => l10n('None of these tags'),
+      'only'  => l10n('Only these tags'),
+      ),
+    'date' => array(
+      'the_post'      => l10n('Added on'),
+      'before_post'   => l10n('Added before'),
+      'after_post'    => l10n('Added after'),
+      'the_taken'     => l10n('Created on'),
+      'before_taken'  => l10n('Created before'),
+      'after_taken'   => l10n('Created after'),
+      ),
+    
+    'name' => array(
+      'contain'     => l10n('Contains'),
+      'begin'       => l10n('Begins with'),
+      'end'         => l10n('Ends with'),
+      'not_contain' => l10n('Doesn\'t contain'),
+      'not_begin'   => l10n('Doesn\'t begin with'),
+      'not_end'     => l10n('Doesn\'t end with'),
+      ),
+    'author' => array(
+      'is'      => l10n('Is'),
+      'in'      => l10n('Is in'),
+      'not_is'  => l10n('Is not'),
+      'not_in'  => l10n('Is not in'),
+      ),
+    'hit' => array(
+      'less' => l10n('Bellow'),
+      'more' => l10n('Above'),
+      ),
+    'level' => array('level' => 'level'), // second filter not used
+    'limit' => array('limit' => 'limit'), // second filter not used
+    )
+  );
+
+/* get filters for this album */
+$query = '
+SELECT * 
+  FROM '.CATEGORY_FILTERS_TABLE.' 
+  WHERE category_id = '.$cat_id.' 
+  ORDER BY 
+    type ASC, 
+    cond ASC
+;';
+$result = pwg_query($query);
+
+while ($filter = pwg_db_fetch_assoc($result))
+{
+  // get tags name and id
+  if ($filter['type'] == 'tags')
+  {
+    $query = '
+SELECT
+    id,
+    name
+  FROM '.TAGS_TABLE.'
+  WHERE id IN('.$filter['value'].')
+;';
+    $filter['value'] = get_taglist($query); 
+  }
+  
+  $template->append('filters', array(
+    'TYPE' => $filter['type'],
+    'COND' => $filter['cond'],
+    'VALUE' => $filter['value'],
+  ));
+}
+
+/* all tags */
+$query = '
+SELECT
+    id,
+    name
+  FROM '.TAGS_TABLE.'
+;';
+$all_tags = get_taglist($query);
+
+/* get image number */
+if ($template->get_template_vars('IMAGE_COUNT') == null)
+{
+  $query = '
+SELECT count(1) 
+  FROM '.IMAGE_CATEGORY_TABLE.' 
+  WHERE 
+    category_id = '.$cat_id.' 
+    AND smart = true
+';
+
+  list($image_num) = pwg_db_fetch_row(pwg_query($query));
+  $template->assign('IMAGE_COUNT', l10n_dec('%d photo', '%d photos', $image_num));
+}
+
+if (isset($_GET['new_smart']))
+{
+  $template->assign('new_smart', true);
+}
+
+$template->assign(array(
+  'COUNT_SCRIPT_URL' => SMART_PATH.'include/count_images.php',
+  'all_tags' => $all_tags,
+  'level_options' => get_privacy_level_options(),
+  'F_ACTION' => $self_url,
+  'CATEGORIES_NAV' => get_cat_display_name_cache(
+    $category['uppercats'],
+    SMART_ADMIN.'-album&amp;cat_id='
+    ),
+));
+
+$template->set_filename('SmartAlbums_content', dirname(__FILE__).'/template/album.tpl');
+
+?>
Index: /extensions/SmartAlbums/admin/cat_list.php
===================================================================
--- /extensions/SmartAlbums/admin/cat_list.php	(revision 16104)
+++ /extensions/SmartAlbums/admin/cat_list.php	(revision 16104)
@@ -0,0 +1,169 @@
+<?php
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+
+if (isset($_GET['hide_messages']))
+{
+  $conf['SmartAlbums']['show_list_messages'] = false;
+  conf_update_param('SmartAlbums', serialize($conf['SmartAlbums']));
+}
+
+// +-----------------------------------------------------------------------+
+// |                            initialization                             |
+// +-----------------------------------------------------------------------+
+$base_url = get_root_url() . 'admin.php?page=';
+$self_url = SMART_ADMIN . '-cat_list';
+
+$categories = array();
+$query = '
+SELECT 
+    id,
+    name,
+    permalink,
+    dir,
+    rank,
+    status
+  FROM '.CATEGORIES_TABLE.' AS cat
+  INNER JOIN '.CATEGORY_FILTERS_TABLE.' AS cf
+    ON cf.category_id = cat.id
+  ORDER BY rank ASC
+;';
+$categories = hash_from_query($query, 'id');
+
+// +-----------------------------------------------------------------------+
+// |                    virtual categories management                      |
+// +-----------------------------------------------------------------------+
+// request to delete a album
+if (isset($_GET['delete']) and is_numeric($_GET['delete']))
+{
+  delete_categories(array($_GET['delete']));
+  $_SESSION['page_infos'] = array(l10n('SmartAlbum deleted'));
+  update_global_rank();
+  redirect($self_url);
+}
+// request to add a album
+else if (isset($_POST['submitAdd']))
+{
+  $output_create = create_virtual_category(
+    $_POST['virtual_name'],
+    @$_POST['parent_id']
+    );
+
+  if (isset($output_create['error']))
+  {
+    array_push($page['errors'], $output_create['error']);
+  }
+  else
+  {
+    $_SESSION['page_infos'] = array(l10n('SmartAlbum added'));
+    $redirect_url = SMART_ADMIN . '-album&amp;cat_id='.$output_create['id'].'&amp;new_smart';
+    redirect($redirect_url);
+  }
+}
+// request to regeneration
+else if (isset($_GET['smart_generate']))
+{
+  /* regenerate photo list | all categories */
+  if ($_GET['smart_generate'] == 'all')
+  {
+    foreach ($categories as $category)
+    {
+      $associated_images = smart_make_associations($category['id']);
+      array_push($page['infos'], 
+        sprintf(l10n('%d photos associated to album %s'), 
+          count($associated_images), 
+          '&laquo;'.trigger_event('render_category_name', $category['name'], 'admin_cat_list').'&raquo;'
+          )
+        );
+    }
+  }
+  /* regenerate photo list | one category */
+  else
+  {
+    $associated_images = smart_make_associations($_GET['smart_generate']);    
+    array_push($page['infos'], 
+      sprintf(l10n('%d photos associated to album %s'), 
+        count($associated_images), 
+        '&laquo;'.trigger_event('render_category_name', $categories[ $_GET['smart_generate'] ]['name'], 'admin_cat_list').'&raquo;'
+        )
+      );
+  }
+  
+  define('SMART_NOT_UPDATE', 1);
+  invalidate_user_cache();
+}
+
+// +-----------------------------------------------------------------------+
+// |                       template initialization                         |
+// +-----------------------------------------------------------------------+
+$template->assign(array(
+  'F_ACTION' => $self_url,
+  'PWG_TOKEN' => get_pwg_token(),
+ ));
+ 
+// retrieve all existing categories for album creation
+$query = '
+SELECT id,name,uppercats,global_rank
+  FROM '.CATEGORIES_TABLE.'
+;';
+
+display_select_cat_wrapper(
+  $query,
+  null,
+  'category_options'
+  );
+  
+if ($conf['SmartAlbums']['show_list_messages'])
+{
+  array_push($page['warnings'], l10n('Only SmartAlbums are displayed on this page'));
+  array_push($page['warnings'], sprintf(l10n('To order albums please go the main albums <a href="%s">management page</a>'), $base_url.'cat_list'));
+  array_push($page['warnings'], '<a href="'.$self_url.'&hide_messages">['.l10n('Don\'t show this message again').']</a>');
+}
+
+// +-----------------------------------------------------------------------+
+// |                          Categories display                           |
+// +-----------------------------------------------------------------------+
+
+// get the categories containing images directly 
+$categories_with_images = array();
+if ( count($categories) )
+{
+  $query = '
+SELECT DISTINCT category_id 
+  FROM '.IMAGE_CATEGORY_TABLE.'
+  WHERE category_id IN ('.implode(',', array_keys($categories)).')';
+  $categories_with_images = array_flip( array_from_query($query, 'category_id') );
+}
+
+$template->assign('categories', array());
+
+foreach ($categories as $category)
+{
+  $tpl_cat =
+    array(
+      'NAME'       => get_cat_display_name_from_id($category['id'], $base_url.'album-'),
+      'ID'         => $category['id'],
+      'RANK'       => $category['rank']*10,
+
+      'U_JUMPTO'   => make_index_url(
+        array(
+          'category' => $category
+          )
+        ),
+
+      'U_EDIT'     => $base_url.'album-'.$category['id'],
+      'U_DELETE'   => $self_url.'&amp;delete='.$category['id'].'&amp;pwg_token='.get_pwg_token(),
+      'U_SMART'    => $self_url.'&amp;smart_generate='.$category['id'],
+    );
+
+  if ( array_key_exists($category['id'], $categories_with_images) )
+  {
+    $tpl_cat['U_MANAGE_ELEMENTS'] =
+      $base_url.'batch_manager&amp;cat='.$category['id'];
+  }
+  
+  $template->append('categories', $tpl_cat);
+}
+
+$template->set_filename('SmartAlbums_content', dirname(__FILE__).'/template/cat_list.tpl');
+
+?>
Index: /extensions/SmartAlbums/admin/config.php
===================================================================
--- /extensions/SmartAlbums/admin/config.php	(revision 16104)
+++ /extensions/SmartAlbums/admin/config.php	(revision 16104)
@@ -0,0 +1,19 @@
+<?php
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+
+// Enregistrement de la configuration
+if (isset($_POST['submit']))
+{
+  $conf['SmartAlbums']['update_on_upload'] = isset($_POST['update_on_upload']);
+  
+  conf_update_param('SmartAlbums', serialize($conf['SmartAlbums']));
+  array_push($page['infos'], l10n('Information data registered in database'));
+}
+
+$template->assign(array(
+  'update_on_upload' => $conf['SmartAlbums']['update_on_upload'],
+));
+
+$template->set_filename('SmartAlbums_content', dirname(__FILE__).'/template/config.tpl');
+
+?>
Index: /extensions/SmartAlbums/admin/index.php
===================================================================
--- /extensions/SmartAlbums/admin/index.php	(revision 16103)
+++ /extensions/SmartAlbums/admin/index.php	(revision 16104)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2011 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
Index: /extensions/SmartAlbums/include/cat_list.php
===================================================================
--- /extensions/SmartAlbums/include/cat_list.php	(revision 16104)
+++ /extensions/SmartAlbums/include/cat_list.php	(revision 16104)
@@ -0,0 +1,111 @@
+<?php
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+/**
+ * Add a link into categories list to regenerate associations
+ */
+$smart_count = 0;
+
+function smart_cat_list()
+{
+  global $template, $page, $smart_count;
+
+  $self_url = get_root_url().'admin.php?page=cat_list'.(isset($_GET['parent_id']) ? '&amp;parent_id='.$_GET['parent_id'] : null);
+  
+  /* get categories with smart filters */
+  $query = '
+SELECT DISTINCT id, name 
+  FROM '.CATEGORIES_TABLE.' AS c
+    INNER JOIN '.CATEGORY_FILTERS_TABLE.' AS cf
+      ON c.id = cf.category_id';
+  if (!isset($_GET['parent_id']))
+  {
+    // $query.= '
+    // WHERE id_uppercat IS NULL';
+  }
+  else
+  {
+    $query .= '
+  WHERE uppercats LIKE \'%'.$_GET['parent_id'].'%\'';
+  }
+  $query .= '
+;';
+  
+  $smart_cats = hash_from_query($query, 'id'); 
+  $smart_count = count($smart_cats);
+  
+  if (isset($_GET['smart_generate']))
+  {
+    /* regenerate photo list | all (sub) categories */
+    if ($_GET['smart_generate'] == 'all')
+    {
+      foreach ($smart_cats as $category)
+      {
+        $associated_images = smart_make_associations($category['id']);
+        array_push($page['infos'], 
+          sprintf(l10n('%d photos associated to album %s'), 
+            count($associated_images), 
+            '&laquo;'.trigger_event('render_category_name', $category['name'], 'admin_cat_list').'&raquo;'
+            )
+          );
+      }
+    }
+    /* regenerate photo list | one category */
+    else
+    {
+      $associated_images = smart_make_associations($_GET['smart_generate']);    
+      array_push($page['infos'], 
+        sprintf(l10n('%d photos associated to album %s'), 
+          count($associated_images), 
+          '&laquo;'.trigger_event('render_category_name', $smart_cats[ $_GET['smart_generate'] ]['name'], 'admin_cat_list').'&raquo;'
+          )
+        );
+    }
+    
+    define('SMART_NOT_UPDATE', 1);
+    invalidate_user_cache();
+  }
+  
+  // create regenerate link
+  $tpl_cat = array();
+  foreach ($smart_cats as $cat => $name)
+  {
+    $tpl_cat[$cat] = $self_url.'&amp;smart_generate='.$cat;
+  }
+  $tpl_cat['all'] = $self_url.'&amp;smart_generate=all';
+  
+  $template->assign(array(
+    'SMART_URL' => $tpl_cat,
+    'SMART_PATH' => SMART_PATH,
+  ));
+  
+  $template->set_prefilter('categories', 'smart_cat_list_prefilter');
+}
+
+
+function smart_cat_list_prefilter($content, &$smarty)
+{
+  global $smart_count;
+  
+  $search[0] = '{if isset($category.U_MANAGE_ELEMENTS) }';
+  $replacement[0] = $search[0].'
+{if isset($SMART_URL[$category.ID])}
+| <a href="{$SMART_URL[$category.ID]}">{\'Regenerate photos list of this SmartAlbum\'|@translate}</a>
+{/if}';
+
+  if ($smart_count > 0)
+  {
+    $search[1] = '<a href="#" id="autoOrderOpen">{\'apply automatic sort order\'|@translate}</a>';
+    $replacement[1] = $search[1].'
+| <a href="{$SMART_URL.all}">{\'Regenerate photos list of all SmartAlbums\'|@translate}</a>';
+  }
+  
+  $search[2] = '{$category.NAME}</a></strong>';
+  $replacement[2] = $search[2].'
+{if isset($SMART_URL[$category.ID])}
+<img src="'.SMART_PATH.'admin/template/lightning.png">
+{/if}';
+
+  return str_replace($search, $replacement, $content);
+}
+
+?>
Index: /extensions/SmartAlbums/include/count_images.php
===================================================================
--- /extensions/SmartAlbums/include/count_images.php	(revision 16103)
+++ /extensions/SmartAlbums/include/count_images.php	(revision 16104)
@@ -6,7 +6,14 @@
 define('PHPWG_ROOT_PATH','./../../../');
 define('IN_ADMIN', true);
+
 include_once(PHPWG_ROOT_PATH.'include/common.inc.php');
+
+if (!is_admin()) die('Hacking attempt!');
+
 include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
 include_once(SMART_PATH.'include/functions.inc.php');
+
+load_language('plugin.lang', SMART_PATH);
+$conf['SmartAlbums'] = unserialize($conf['SmartAlbums']);
 
 if (isset($_POST['filters']))
@@ -22,4 +29,9 @@
       array_push($filters, $filter);
     }
+    else
+    {
+      echo '<span class="filter_error">'.$page['errors'][ count($page['errors'])-1 ].'</span>';
+      exit;
+    }
   }
 
@@ -31,5 +43,5 @@
 }
 
-echo l10n_dec('%d photo', '%d photos', count($associated_images));
+echo '<span class="count_image">'.l10n_dec('%d photo', '%d photos', count($associated_images)).'</span>';
 
 ?>
